#version 320

precision highp float;

layout(binding=0) uniform BlockFragment {
	vec4 pParam1;
};

layout(location = 0, binding = 0) uniform sampler2D Sampler0;

in vec2 texCoord;
in vec4 t1;
in vec4 t2;
in vec4 t3;
in vec4 t4;

layout(location = 0) out vec4 pColor;

void main()
{
	//vec3 dt = pParam1.xyz;
	
	vec3 dt = vec3(1.0, 1.0, 1.0);
	
	vec3 c00 = texture(Sampler0, t1.xy).xyz; 
	vec3 c10 = texture(Sampler0, t1.zw).xyz; 
	vec3 c20 = texture(Sampler0, t2.xy).xyz; 
	vec3 c01 = texture(Sampler0, t4.zw).xyz; 
	vec3 c11 = texture(Sampler0, texCoord).xyz; 
	vec3 c21 = texture(Sampler0, t2.zw).xyz; 
	vec3 c02 = texture(Sampler0, t4.xy).xyz; 
	vec3 c12 = texture(Sampler0, t3.zw).xyz; 
	vec3 c22 = texture(Sampler0, t3.xy).xyz; 

	float d1=dot(abs(c00-c22),dt)+0.0001;
	float d2=dot(abs(c20-c02),dt)+0.0001;
	float hl=dot(abs(c01-c21),dt)+0.0001;
	float vl=dot(abs(c10-c12),dt)+0.0001;

	float k1=0.5*(hl+vl);
	float k2=0.5*(d1+d2);

	vec3 s1=(hl*(c10+c12)+vl*(c01+c21)+k1*c11)/(2.5*(hl+vl));
	vec3 s2=(d1*(c20+c02)+d2*(c00+c22)+k2*c11)/(2.5*(d1+d2));

	k1=dot(abs(s1-c11),dt)+0.0001;
	k2=dot(abs(s2-c11),dt)+0.0001;
   
	pColor.rgb = vec3((k1*s2+k2*s1)/(k1+k2));


   // alpha compute

	c00 = vec3(texture(Sampler0, t1.xy).a); 
	c10 = vec3(texture(Sampler0, t1.zw).a); 
	c20 = vec3(texture(Sampler0, t2.xy).a); 
	c01 = vec3(texture(Sampler0, t4.zw).a); 
	c11 = vec3(texture(Sampler0, texCoord).a); 
	c21 = vec3(texture(Sampler0, t2.zw).a); 
	c02 = vec3(texture(Sampler0, t4.xy).a); 
	c12 = vec3(texture(Sampler0, t3.zw).a); 
	c22 = vec3(texture(Sampler0, t3.xy).a); 

	d1=dot(abs(c00-c22),dt)+0.0001;
	d2=dot(abs(c20-c02),dt)+0.0001;
	hl=dot(abs(c01-c21),dt)+0.0001;
	vl=dot(abs(c10-c12),dt)+0.0001;

	k1=0.5*(hl+vl);
	k2=0.5*(d1+d2);

	s1=(hl*(c10+c12)+vl*(c01+c21)+k1*c11)/(2.5*(hl+vl));
	s2=(d1*(c20+c02)+d2*(c00+c22)+k2*c11)/(2.5*(d1+d2));

	k1=dot(abs(s1-c11),dt)+0.0001;
	k2=dot(abs(s2-c11),dt)+0.0001;
   
	pColor.a = vec3((k1*s2+k2*s1)/(k1+k2)).r;

    if(pColor.a < pParam1.z)
		pColor.a = 0.0;	
	
	if (pParam1.w > 0.0)
	{
		gl_FragDepth = pColor.r;
	}
}
