#version 320

// Bilinear Fragment Shader
// Ported by Hyllian

precision highp float;

layout(binding=0) uniform BlockFragment {
	vec4 pParam1;
};

layout(location = 0, binding = 0) uniform sampler2D Sampler0;

in vec2 texCoord;
in vec4 t1;

layout(location = 0) out vec4 pColor;

void main()
{
	//vec3 dt = pParam1.xyz;

	vec2 pos = fract(texCoord*pParam1.xy) - vec2(0.5, 0.5);
	vec2 dir = sign(pos);
	
	vec2 g1 = dir*t1.xy;
	vec2 g2 = dir*t1.zw;

	vec3 A = texture(Sampler0,texCoord        ).xyz;
	vec3 B = texture(Sampler0,texCoord +g1    ).xyz;
	vec3 C = texture(Sampler0,texCoord     +g2).xyz;
	vec3 D = texture(Sampler0,texCoord +g1 +g2).xyz;

	float p = abs(pos.x);
	float q = abs(pos.y);

	pColor.rgb = vec3((1.0-p)*(1.0-q)*A + p*(1.0-q)*B + (1.0-p)*q*C + p*q*D);

   // alpha compute

	A = vec3(texture(Sampler0,texCoord        ).a);
	B = vec3(texture(Sampler0,texCoord +g1    ).a);
	C = vec3(texture(Sampler0,texCoord     +g2).a);
	D = vec3(texture(Sampler0,texCoord +g1 +g2).a);

	pColor.a = vec3((1.0-p)*(1.0-q)*A + p*(1.0-q)*B + (1.0-p)*q*C + p*q*D).r;

    if(pColor.a < pParam1.z)
		pColor.a = 0.0;	
	
	if (pParam1.w > 0.0)
	{
		gl_FragDepth = pColor.r;
	}
}
