#version 320

precision highp float;

layout(binding=0) uniform BlockVertex {
	vec4 vParam1;
};

layout(location = 0) in vec4 VertexCoord;
layout(location = 1) in vec2 TextureCoord;
layout(location = 1) in vec2 Color;

out vec2 texCoord;
out vec4 t1;
out vec4 t2;
out vec4 t3;
out vec4 t4;
out vec4 t5;
out vec4 t6;
out vec4 t7;

void main()
{
    gl_Position = vec4(VertexCoord.xy, 0.0, 1.0);
	
	float dx = 1.0 / vParam1.x;
	float dy = 1.0 / vParam1.y;
	
	texCoord = TextureCoord;
	t1 = TextureCoord.xxxy + vec4( -dx, 0, dx,-2.0*dy); // A1 B1 C1
	t2 = TextureCoord.xxxy + vec4( -dx, 0, dx,    -dy); //  A  B  C
	t3 = TextureCoord.xxxy + vec4( -dx, 0, dx,      0); //  D  E  F
	t4 = TextureCoord.xxxy + vec4( -dx, 0, dx,     dy); //  G  H  I
	t5 = TextureCoord.xxxy + vec4( -dx, 0, dx, 2.0*dy); // G5 H5 I5
	t6 = TextureCoord.xyyy + vec4(-2.0*dx,-dy, 0,  dy); // A0 D0 G0
	t7 = TextureCoord.xyyy + vec4( 2.0*dx,-dy, 0,  dy); // C4 F4 I4
}
